# class Encoding::InvalidByteSequenceError

Raised by `Encoding` and `String` methods when the string being transcoded contains a byte invalid for the either the source or target encoding.

### Public Instance Methods

destination_encoding → string click to toggle source

Returns the destination encoding as an encoding object.

    static VALUE
    ecerr_destination_encoding(VALUE self)
    {
        return rb_attr_get(self, id_destination_encoding);
    }

destination_encoding_name → string click to toggle source

Returns the destination encoding name as a string.

    static VALUE
    ecerr_destination_encoding_name(VALUE self)
    {
        return rb_attr_get(self, id_destination_encoding_name);
    }

error_bytes → string click to toggle source

Returns the discarded bytes when `Encoding::InvalidByteSequenceError` occurs.

    ec = Encoding::Converter.new("EUC-JP", "ISO-8859-1")
    begin
      ec.convert("abc\xA1\xFFdef")
    rescue Encoding::InvalidByteSequenceError
      p $!      #=> #<Encoding::InvalidByteSequenceError: "\xA1" followed by "\xFF" on EUC-JP>
      puts $!.error_bytes.dump          #=> "\xA1"
      puts $!.readagain_bytes.dump      #=> "\xFF"
    end

    static VALUE
    ecerr_error_bytes(VALUE self)
    {
        return rb_attr_get(self, id_error_bytes);
    }

incomplete_input? → true or false click to toggle source

Returns true if the invalid byte sequence error is caused by premature end of string.

    ec = Encoding::Converter.new("EUC-JP", "ISO-8859-1")

    begin
      ec.convert("abc\xA1z")
    rescue Encoding::InvalidByteSequenceError
      p $!      #=> #<Encoding::InvalidByteSequenceError: "\xA1" followed by "z" on EUC-JP>
      p $!.incomplete_input?    #=> false
    end

    begin
      ec.convert("abc\xA1")
      ec.finish
    rescue Encoding::InvalidByteSequenceError
      p $!      #=> #<Encoding::InvalidByteSequenceError: incomplete "\xA1" on EUC-JP>
      p $!.incomplete_input?    #=> true
    end

    static VALUE
    ecerr_incomplete_input(VALUE self)
    {
        return rb_attr_get(self, id_incomplete_input);
    }

readagain_bytes → string click to toggle source

Returns the bytes to be read again when `Encoding::InvalidByteSequenceError` occurs.

    static VALUE
    ecerr_readagain_bytes(VALUE self)
    {
        return rb_attr_get(self, id_readagain_bytes);
    }

source_encoding → encoding click to toggle source

Returns the source encoding as an encoding object.

Note that the result may not be equal to the source encoding of the encoding converter if the conversion has multiple steps.

    ec = Encoding::Converter.new("ISO-8859-1", "EUC-JP") # ISO-8859-1 -> UTF-8 -> EUC-JP
    begin
      ec.convert("\xa0") # NO-BREAK SPACE, which is available in UTF-8 but not in EUC-JP.
    rescue Encoding::UndefinedConversionError
      p $!.source_encoding              #=> #<Encoding:UTF-8>
      p $!.destination_encoding         #=> #<Encoding:EUC-JP>
      p $!.source_encoding_name         #=> "UTF-8"
      p $!.destination_encoding_name    #=> "EUC-JP"
    end

    static VALUE
    ecerr_source_encoding(VALUE self)
    {
        return rb_attr_get(self, id_source_encoding);
    }

source_encoding_name → string click to toggle source

Returns the source encoding name as a string.

    static VALUE
    ecerr_source_encoding_name(VALUE self)
    {
        return rb_attr_get(self, id_source_encoding_name);
    }